// ==UserScript==
// @name         Video Controls
// @namespace    http://tampermonkey.net/
// @version      0.1
// @description  try to take over the world!
// @author       You
// @match        *
// @icon         https://www.google.com/s2/favicons?sz=64&domain=tampermonkey.net
// @grant        none
// ==/UserScript==
// @ts-ignore
if (typeof videoControllerDefined === "undefined") {
    var videoControllerDefined = true;
    console.log("init (videoControllerDefined is undefined) -> starting");
    var run = function () {
        var PORT_NAME = "videocontrols_ext_port";
        var MIN_DURATION = 60 * 1; // 1 minute
        var CHECK_MIN_DURATION = true;
        function getHumanReadableTimeFromSecs(seconds) {
            var hours = Math.floor(seconds / 3600);
            var minutes = Math.floor(seconds / 60);
            var secs = Math.floor(seconds % 60);
            // hours > 0 -> minutes and seconds are always 2 digits
            // minutes > 0 -> seconds are always 2 digits
            if (hours > 0) {
                return "".concat(hours, ":").concat(minutes.toString().padStart(2, "0"), ":").concat(secs
                    .toString()
                    .padStart(2, "0"));
            }
            else {
                return "".concat(minutes, ":").concat(secs.toString().padStart(2, "0"));
            }
        }
        try {
            var DEBUG_LAYOUT_1 = false; // show player controls even if there is no video element
            var styles = document.createElement("style");
            styles.setAttribute("type", "text/css");
            styles.textContent = "#xtfs_wrapper {\n      position: fixed;\n      bottom: 0;\n      left: 0;\n      width: 100%;\n      margin: 0;\n      padding: 0;\n      border: 0;\n      text-align: center;\n      border-radius: 0;\n      z-index: 9999;\n    }\n    #xtfs_collapseWrapper {\n      position: relative;\n      height: 40px;\n      width: 100%;\n    }\n    #xtfs_collapseWrapper > button {\n      position: absolute;\n      top: 0;\n      right: 0;\n      height: 40px;\n      width: 100px;\n      background: #3d4a53 !important;\n      border-top-left-radius: 10px !important;\n      border-top-right-radius: 10px !important;\n      border: 0;\n      cursor: pointer;\n      color: #fff;\n      fill: #fff;\n      display: flex;\n      align-items: center;\n      justify-content: center;\n    }\n    #xtfs_collapseWrapper > button svg {\n      color: #fff;\n      fill: #fff;\n      height: 30px;\n      width: auto;\n      rotate: 0deg;\n      transition: all 1s;\n    }\n    #xtfs_collapseWrapper > button.collapsed svg {\n      rotate: 180deg;\n    }\n    #xtfs_progressWrapper {\n      background: #3d4a53;\n      height: 7px;\n    }\n    #xtfs_progressWrapper #xtfs_progress {\n      height: 7px;\n      width: 0%;\n      background-color: red;\n      padding: 0;\n      margin: 0;\n    }\n    #xtfs_controlsWrapper {\n      display: flex;\n      justify-content: space-between;\n      align-items: center;\n      box-sizing: border-box;\n      position: relative;\n      margin: 0;\n      padding: 0;\n      border: 0;\n      background-color: #000000;\n      border-radius: 0;\n      overflow: hidden;\n      transition: all 1s;\n      height: 0px;\n      min-height: 70px;\n    }\n    #xtfs_controlsWrapper > * {\n      transition: all 0.2s;\n      opacity: 1;\n    }\n    #xtfs_controlsWrapper.collapsed {\n      height: 0px !important;\n      min-height: 0px !important;\n    }\n    #xtfs_controlsWrapper.collapsed > * {\n      opacity: 0;\n    }\n    #xtfs_controlsWrapper #xtfs_controls {\n      height: 70%;\n      max-height: 70px;\n    }\n    #xtfs_controlsWrapper #xtfs_currentTime,\n    #xtfs_controlsWrapper #xtfs_duration {\n      font-size: 25px;\n      color: #fff;\n      font-family: \"Courier New\", Courier, monospace;\n      font-weight: 700;\n      padding: 10px 20px;\n      line-height: 25px;\n    }\n    #xtfs_controlsWrapper #xtfs_controls > button {\n      background: #1f2628 !important;\n      padding: 7px 30px !important;\n      margin: 0px 5px !important;\n      border-radius: 25% !important;\n      color: #fff;\n      border: 0;\n      height: 100%;\n    }\n    #xtfs_wrapper #xtfs_controls > button svg {\n      fill: #fff;\n      height: 30px;\n      width: auto;\n    }";
            document.head.appendChild(styles);
            var wrapper_1 = document.createElement("div");
            wrapper_1.id = "xtfs_wrapper";
            var collapseWrapper = document.createElement("div");
            collapseWrapper.id = "xtfs_collapseWrapper";
            var progressWrapper = document.createElement("div");
            progressWrapper.id = "xtfs_progressWrapper";
            var controlsWrapper_1 = document.createElement("div");
            controlsWrapper_1.id = "xtfs_controlsWrapper";
            wrapper_1.appendChild(collapseWrapper);
            wrapper_1.appendChild(progressWrapper);
            wrapper_1.appendChild(controlsWrapper_1);
            var currentTimeElem_1 = document.createElement("div");
            currentTimeElem_1.id = "xtfs_currentTime";
            var controlsElem = document.createElement("div");
            controlsElem.id = "xtfs_controls";
            var durationElem_1 = document.createElement("div");
            durationElem_1.id = "xtfs_duration";
            controlsWrapper_1.appendChild(currentTimeElem_1);
            controlsWrapper_1.appendChild(controlsElem);
            controlsWrapper_1.appendChild(durationElem_1);
            var rewindButton = document.createElement("button");
            var rewindSvg = "<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>rewind-10</title><path d=\"M12.5,3C17.15,3 21.08,6.03 22.47,10.22L20.1,11C19.05,7.81 16.04,5.5 12.5,5.5C10.54,5.5 8.77,6.22 7.38,7.38L10,10H3V3L5.6,5.6C7.45,4 9.85,3 12.5,3M10,12V22H8V14H6V12H10M18,14V20C18,21.11 17.11,22 16,22H14A2,2 0 0,1 12,20V14A2,2 0 0,1 14,12H16C17.11,12 18,12.9 18,14M14,14V20H16V14H14Z\" /></svg>";
            rewindButton.id = "rewindButton";
            rewindButton.innerHTML = rewindSvg;
            controlsElem.appendChild(rewindButton);
            var playButton_1 = document.createElement("button");
            var playSvg_1 = "<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>play</title><path d=\"M8,5.14V19.14L19,12.14L8,5.14Z\" /></svg>";
            var pauseSvg_1 = "<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>pause</title><path d=\"M14,19H18V5H14M6,19H10V5H6V19Z\" /></svg>";
            playButton_1.id = "playButton";
            playButton_1.innerHTML = playSvg_1;
            controlsElem.appendChild(playButton_1);
            var forwardButton = document.createElement("button");
            var forwardSvg = "<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>fast-forward-10</title><path d=\"M10,12V22H8V14H6V12H10M18,14V20C18,21.11 17.11,22 16,22H14A2,2 0 0,1 12,20V14A2,2 0 0,1 14,12H16C17.11,12 18,12.9 18,14M14,14V20H16V14H14M11.5,3C14.15,3 16.55,4 18.4,5.6L21,3V10H14L16.62,7.38C15.23,6.22 13.46,5.5 11.5,5.5C7.96,5.5 4.95,7.81 3.9,11L1.53,10.22C2.92,6.03 6.85,3 11.5,3Z\" /></svg>";
            forwardButton.id = "forwardButton";
            forwardButton.innerHTML = forwardSvg;
            controlsElem.appendChild(forwardButton);
            var fullscreenButton = document.createElement("button");
            var fullscreenSvg = "<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>fullscreen</title><path d=\"M5,5H10V7H7V10H5V5M14,5H19V10H17V7H14V5M17,14H19V19H14V17H17V14M10,17V19H5V14H7V17H10Z\" /></svg>";
            fullscreenButton.id = "fullscreenButton";
            fullscreenButton.innerHTML = fullscreenSvg;
            controlsElem.appendChild(fullscreenButton);
            // youtube.com video settings
            if (window.location.href.includes("youtube.com")) {
                var settingsButton = document.createElement("button");
                var cogSvg = "<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>cog</title><path d=\"M12,15.5A3.5,3.5 0 0,1 8.5,12A3.5,3.5 0 0,1 12,8.5A3.5,3.5 0 0,1 15.5,12A3.5,3.5 0 0,1 12,15.5M19.43,12.97C19.47,12.65 19.5,12.33 19.5,12C19.5,11.67 19.47,11.34 19.43,11L21.54,9.37C21.73,9.22 21.78,8.95 21.66,8.73L19.66,5.27C19.54,5.05 19.27,4.96 19.05,5.05L16.56,6.05C16.04,5.66 15.5,5.32 14.87,5.07L14.5,2.42C14.46,2.18 14.25,2 14,2H10C9.75,2 9.54,2.18 9.5,2.42L9.13,5.07C8.5,5.32 7.96,5.66 7.44,6.05L4.95,5.05C4.73,4.96 4.46,5.05 4.34,5.27L2.34,8.73C2.21,8.95 2.27,9.22 2.46,9.37L4.57,11C4.53,11.34 4.5,11.67 4.5,12C4.5,12.33 4.53,12.65 4.57,12.97L2.46,14.63C2.27,14.78 2.21,15.05 2.34,15.27L4.34,18.73C4.46,18.95 4.73,19.03 4.95,18.95L7.44,17.94C7.96,18.34 8.5,18.68 9.13,18.93L9.5,21.58C9.54,21.82 9.75,22 10,22H14C14.25,22 14.46,21.82 14.5,21.58L14.87,18.93C15.5,18.67 16.04,18.34 16.56,17.94L19.05,18.95C19.27,19.03 19.54,18.95 19.66,18.73L21.66,15.27C21.78,15.05 21.73,14.78 21.54,14.63L19.43,12.97Z\" /></svg>";
                settingsButton.id = "settingsButton";
                settingsButton.innerHTML = cogSvg;
                controlsElem.appendChild(settingsButton);
                settingsButton.onclick = function () {
                    //@ts-ignore
                    document.querySelector(".html5-video-container").click();
                    //@ts-ignore
                    setTimeout(function () {
                        var _a;
                        return (_a = document
                            .querySelector(".icon-button.player-settings-icon")) === null || _a === void 0 ? void 0 : _a.click();
                    }, 250);
                };
            }
            var toggleBtn_1 = document.createElement("button");
            var closeButtonSvg = "<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>chevron-down</title><path d=\"M7.41,8.58L12,13.17L16.59,8.58L18,10L12,16L6,10L7.41,8.58Z\" /></svg>";
            toggleBtn_1.id = "toggleBtn";
            toggleBtn_1.innerHTML = closeButtonSvg;
            collapseWrapper.appendChild(toggleBtn_1);
            var progressBar_1 = document.createElement("div");
            progressBar_1.id = "xtfs_progress";
            progressWrapper.appendChild(progressBar_1);
            var playerState_1 = {
                id: "".concat(Math.floor(Math.random() * 100000)),
                playing: false,
                duration: 0,
                currentTime: 0
            };
            var updateProgressBar_1 = function () {
                try {
                    if ((videoElement_1 != null &&
                        !videoElement_1.paused &&
                        videoElement_1.duration > 0) ||
                        DEBUG_LAYOUT_1) {
                        currentTimeElem_1.innerHTML = getHumanReadableTimeFromSecs(playerState_1.currentTime);
                        durationElem_1.innerHTML = getHumanReadableTimeFromSecs(playerState_1.duration);
                        var progress = playerState_1.currentTime / playerState_1.duration;
                        progressBar_1.style.width = "".concat(progress * 100, "%");
                    }
                    else {
                        if (videoElement_1 == null) {
                            progressBar_1.style.width = "0%";
                            currentTimeElem_1.innerHTML = "0:00";
                            durationElem_1.innerHTML = "-:--";
                        }
                    }
                }
                catch (e) {
                    console.error(e);
                }
            };
            var kotlinVideoUrlFound_1 = function () {
                try {
                    // @ts-ignore
                    return KotlinBridge.videoUrlFound();
                }
                catch (e) {
                    console.error(e);
                    return false;
                }
            };
            var kotlinOpenVideoPlayer_1 = function (currentPosition) {
                try {
                    // @ts-ignore
                    KotlinBridge.openVideoPlayerActivity(currentPosition);
                }
                catch (e) {
                    console.error(e);
                }
            };
            var controllersAttached_1 = false;
            var closed_1 = false; // once closed, don't show again
            var videoElement_1 = null;
            var canAttachControllers_1 = false; // only attach controllers if video is/was playing
            var currentLocation_1 = window.location.href;
            playButton_1.onclick = function () {
                if (DEBUG_LAYOUT_1) {
                    watcher_1.playing = !watcher_1.playing;
                    return;
                }
                if (playerState_1.playing) {
                    videoElement_1 === null || videoElement_1 === void 0 ? void 0 : videoElement_1.pause();
                }
                else {
                    videoElement_1 === null || videoElement_1 === void 0 ? void 0 : videoElement_1.play();
                }
            };
            fullscreenButton.onclick = function () {
                if (kotlinVideoUrlFound_1()) {
                    kotlinOpenVideoPlayer_1((videoElement_1 === null || videoElement_1 === void 0 ? void 0 : videoElement_1.currentTime) || 0);
                }
                else {
                    videoElement_1 === null || videoElement_1 === void 0 ? void 0 : videoElement_1.requestFullscreen();
                }
            };
            rewindButton.onclick = function () {
                if (videoElement_1 != null) {
                    videoElement_1.currentTime = Math.max(0, videoElement_1.currentTime - 10);
                }
            };
            forwardButton.onclick = function () {
                if (videoElement_1 != null) {
                    videoElement_1.currentTime = Math.min(videoElement_1.duration, videoElement_1.currentTime + 10);
                }
            };
            var videoDurationOk_1 = function () {
                if (!CHECK_MIN_DURATION) {
                    return true;
                }
                return videoElement_1 != null && videoElement_1.duration > MIN_DURATION;
            };
            var expand_1 = function () {
                console.log("expand: controllersAttached=".concat(controllersAttached_1, ", closed=").concat(closed_1, ", canAttachControllers=").concat(canAttachControllers_1, ", videoElement=").concat(videoElement_1));
                if ((!controllersAttached_1 &&
                    !closed_1 &&
                    videoElement_1 &&
                    videoDurationOk_1() &&
                    canAttachControllers_1) ||
                    DEBUG_LAYOUT_1) {
                    console.log("expand");
                    controllersAttached_1 = true;
                    controlsWrapper_1.classList.remove("collapsed");
                    setTimeout(function () {
                        controlsWrapper_1.style.height = "10vh";
                    }, 100);
                    toggleBtn_1.classList.remove("collapsed");
                    console.log("Video controllers attached");
                }
                else {
                    var hasVideoElement = videoElement_1 ? "true" : "false";
                    var hasCanAttachControllers = canAttachControllers_1
                        ? "true"
                        : "false";
                    console.warn("Video controllers not attached: videoDuration: ".concat(videoElement_1 === null || videoElement_1 === void 0 ? void 0 : videoElement_1.duration, " controllersAttached=").concat(controllersAttached_1, ", closed=").concat(closed_1, ", canAttachControllers=").concat(hasCanAttachControllers, ", videoElement=").concat(hasVideoElement));
                }
            };
            var collapse_1 = function () {
                if (controllersAttached_1) {
                    console.log("collapse");
                    controllersAttached_1 = false;
                    controlsWrapper_1.classList.add("collapsed");
                    toggleBtn_1.classList.add("collapsed");
                    console.log("Video controllers detached");
                }
            };
            if (DEBUG_LAYOUT_1) {
                canAttachControllers_1 = true;
                expand_1();
            }
            toggleBtn_1.onclick = function () {
                console.log("closed: " + closed_1);
                if (!closed_1) {
                    closed_1 = true;
                    collapse_1();
                }
                else {
                    closed_1 = false;
                    expand_1();
                }
            };
            // @ts-ignore
            var watcher_1 = new Proxy(playerState_1, {
                set: function (target, property, value) {
                    if (property === "playing") {
                        console.log("Playing changed: " + value);
                        if (value) {
                            playButton_1.innerHTML = pauseSvg_1;
                        }
                        else {
                            playButton_1.innerHTML = playSvg_1;
                        }
                    }
                    // @ts-ignore
                    target[property] = value;
                    return true;
                }
            });
            // iframe message receiver
            // if this code is running in an iframe, it will receive messages from the parent window
            // window.frames[0].postMessage({ action : "pause"}, '*')
            var isIframe_1 = window.location !== window.parent.location;
            if (isIframe_1) {
                function receiver(msg) {
                    var action = msg.data.action;
                    switch (action) {
                        case "play":
                            videoElement_1 === null || videoElement_1 === void 0 ? void 0 : videoElement_1.play();
                            break;
                        case "pause":
                            videoElement_1 === null || videoElement_1 === void 0 ? void 0 : videoElement_1.pause();
                            break;
                        case "seek":
                            var seekTo = msg.data.seekTo;
                            if (videoElement_1 != null) {
                                videoElement_1.currentTime = seekTo;
                            }
                            break;
                        case "forward":
                            if (videoElement_1 != null) {
                                var seconds = msg.data.seconds;
                                videoElement_1.currentTime = Math.min(videoElement_1.duration, videoElement_1.currentTime + seconds);
                            }
                            break;
                        case "rewind":
                            if (videoElement_1 != null) {
                                var seconds = msg.data.seconds;
                                videoElement_1.currentTime = Math.max(0, videoElement_1.currentTime - seconds);
                            }
                            break;
                    }
                }
                window.addEventListener("message", receiver, false);
            }
            // end iframe callbacks
            // callbacks to native app
            var kotlinOnPlayerStateChange_1 = function (videoFound, playing, videoSrc) {
                try {
                    // @ts-ignore
                    KotlinBridge.onPlayerStateChange(isIframe_1, videoFound, playing, videoSrc);
                }
                catch (e) {
                    console.error(e);
                }
            };
            var kotlinOnProgressChange_1 = function (currentTime, duration) {
                try {
                    // @ts-ignore
                    KotlinBridge.onProgressChange(isIframe_1, currentTime, duration);
                }
                catch (e) {
                    console.error("Catched error:", e);
                }
            };
            var kotlinOnSeeking_1 = function () {
                try {
                    // @ts-ignore
                    KotlinBridge.onSeeking(isIframe_1);
                }
                catch (e) {
                    console.error(e);
                }
            };
            var kotlinOnWaiting_1 = function () {
                try {
                    // @ts-ignore
                    KotlinBridge.onWaiting(isIframe_1);
                }
                catch (e) {
                    console.error(e);
                }
            };
            var kotlinOnLoadedData_1 = function () {
                try {
                    // @ts-ignore
                    KotlinBridge.onLoadedData(isIframe_1);
                }
                catch (e) {
                    console.error(e);
                }
            };
            var kotlinOnSeeked_1 = function () {
                try {
                    // @ts-ignore
                    KotlinBridge.onSeeked(isIframe_1);
                }
                catch (e) {
                    console.error(e);
                }
            };
            var onLocationChange_1 = function () {
                closed_1 = false;
                videoElement_1 = null;
                collapse_1();
                kotlinOnPlayerStateChange_1(videoElement_1 != null, false, "");
            };
            var playingCallback_1 = function () {
                console.log("Video playing");
                watcher_1.playing = true;
                canAttachControllers_1 = true;
                if (!videoDurationOk_1()) {
                    console.log("playingCallback: Video duration is less than " + MIN_DURATION, videoElement_1 === null || videoElement_1 === void 0 ? void 0 : videoElement_1.duration);
                    canAttachControllers_1 = false;
                }
                kotlinOnPlayerStateChange_1(true, true, (videoElement_1 === null || videoElement_1 === void 0 ? void 0 : videoElement_1.src) || "");
            };
            var pauseCallback_1 = function () {
                //console.log("Video paused");
                watcher_1.playing = false;
                kotlinOnPlayerStateChange_1(true, false, (videoElement_1 === null || videoElement_1 === void 0 ? void 0 : videoElement_1.src) || "");
            };
            var timeUpdateCallback_1 = function () {
                if (videoElement_1 != null) {
                    playerState_1.currentTime = videoElement_1.currentTime;
                    kotlinOnProgressChange_1(videoElement_1.currentTime, videoElement_1.duration);
                }
            };
            var seekingCallback_1 = function (event) {
                kotlinOnSeeking_1();
            };
            var seekedCallback_1 = function (event) {
                kotlinOnSeeked_1();
            };
            var waitingCallback_1 = function (event) {
                kotlinOnWaiting_1();
            };
            var loadedDataCallback_1 = function (event) {
                kotlinOnLoadedData_1();
            };
            if (!DEBUG_LAYOUT_1) {
                console.log("Starting interval");
                var ctr_1 = 0;
                setInterval(function () {
                    try {
                        ctr_1++;
                        console.log("Interval: " + ctr_1);
                        var video = document.querySelector("video[src]");
                        console.log("Video found: ".concat(video != null));
                        var location_1 = window.location.href;
                        // FIX xhamster http source inside https website
                        if (window.location.host.includes("xhamster.com")) {
                            if (video) {
                                var src = video.src;
                                if (src.startsWith("http://")) {
                                    video.src = src.replace("http://", "https://");
                                }
                            }
                        }
                        if (location_1 != currentLocation_1) {
                            //videoElement = null; // reset video element when location changes
                            currentLocation_1 = location_1;
                            //port.reconnect();
                            console.warn("Location changed");
                            onLocationChange_1();
                            return;
                        }
                        //console.log(`Video found: ${video != null}`);
                        if (videoElement_1 != video) {
                            videoElement_1 = video;
                            console.log("Video element changed");
                            if (videoElement_1 != null) {
                                console.log("setting event listeners");
                                if (!videoElement_1.paused) {
                                    canAttachControllers_1 = true;
                                }
                                videoElement_1.addEventListener("playing", playingCallback_1);
                                videoElement_1.addEventListener("pause", pauseCallback_1);
                                videoElement_1.addEventListener("timeupdate", timeUpdateCallback_1);
                                videoElement_1.addEventListener("seeking", seekingCallback_1);
                                videoElement_1.addEventListener("seeked", seekedCallback_1);
                                videoElement_1.addEventListener("waiting", waitingCallback_1);
                                videoElement_1.addEventListener("loadeddata", loadedDataCallback_1);
                            }
                        }
                        updateProgressBar_1();
                        // NOTE: get from KotlinBridge
                        var blacklistUrls = [
                            "youtube.com/shorts",
                            "tiktok.com",
                            "instagram.com",
                            "twitter.com",
                            "facebook.com",
                            "reddit.com",
                            "google.com",
                            "chaturbate.com",
                            "xhamsterlive.com",
                            "twitch.tv",
                        ];
                        var url_1 = window.location.href;
                        var blacklistMatch = blacklistUrls.find(function (u) { return url_1.includes(u); });
                        console.log("blacklistMatch: ".concat(blacklistMatch, " , video: ").concat(video != null, " , canAttachControllers: ").concat(canAttachControllers_1));
                        if (video &&
                            !blacklistMatch &&
                            canAttachControllers_1 &&
                            videoDurationOk_1()) {
                            document.body.appendChild(wrapper_1);
                            console.log("Video found -> expand");
                            expand_1();
                        }
                        else {
                            wrapper_1.remove();
                            if (!DEBUG_LAYOUT_1) {
                                console.log("Video not found -> collapse");
                                collapse_1();
                            }
                        }
                        // update player status
                        if (videoElement_1) {
                            playerState_1.duration = videoElement_1.duration;
                            playerState_1.currentTime = videoElement_1.currentTime;
                        }
                    }
                    catch (e) {
                        console.error(e);
                    }
                }, 500);
            }
            else {
                // simulate video playing
                var time_1 = 0.0;
                var simulationInterval = setInterval(function () {
                    playerState_1.duration = 250;
                    time_1 += 0.1;
                    playerState_1.currentTime = time_1;
                    updateProgressBar_1();
                }, 100);
            }
        }
        catch (e) {
            console.error(e);
        }
    };
    try {
        run();
    }
    catch (e) {
        console.error("run error:", e);
    }
}
else {
    console.warn("init (videoControllerDefined is defined)");
}
